******************************************************************************
* $Id: menu.s,v 1.6 1998/12/19 05:24:37 tonya WK $
*
* $Log: menu.s,v $
* Revision 1.6  1998/12/19 05:24:37  tonya
* Added m4 conditional compilation patch
*
* Revision 1.5  1998/12/13 01:19:45  tonya
* Added FSTCALL support
*
* Revision 1.4  1998/11/06 05:28:15  tonya
* If the first RPL word is DirLabel: then we can handle it ourselves
*
* Revision 1.3  1998/06/13 21:25:45  aschoorl
* Added conditional FNT1 usage instead of smallfont
*
* Revision 1.2  1997/12/06 06:10:15  aschoorl
* Standardized comments, changed KEYINBUFFER? to KeyInBuffer?
*
******************************************************************************

	STITLE  ML_DispMenu

******************************************************************************
**
** Name: ML_DispMenu
**
** Category: Display
**
** Abstract: displays the menu
**
** Entry:
**
** Exit:
**
** Error Exits: insufficient memory
**
** Alters: CPU - Just about everything
**         RAM - Buffer$, HARDBUFF2
**
** Calls:    SAVPTR     : saves RPL registers
**           GETPTRLOOP : restores RPL registers and continues RPL
**           D0->Sft1   : machine independent D0 = first nib of HARDBUFF2
**	     PopASavptr
**
** Stack Levels: .....
**
**     Date     Prog             Modification
**   --------   ----   ------------------------------------------
**   Jan 1995   RHS    Full ML rewrite (ie implemented) ;)
**   06/09/95   A.S.   ALLOC -> MALLOC for GNU-Tools
**   Sep24'95   A.S.   sGARB -> sGARBAGE (conflicted with ML decomp)
**   Oct29'97   P.C.   Modified to make it work with FNT1
******************************************************************************

******************************************************************************
** Jazz Debugger Defines
DEFINE	SHALT		ROMPTR 3E0 9

**** Main ********************************************************************
NULLNAME	?Dispmenu

m4_ifdef([[UseFNT1]],[[

::
 DoFSTCALL(KeyInBuffer?)
 case SetDA3Bad		( no time to update, so signal bad )
 TURNMENUON
 FNT1
 NULL$ SIXTEEN EXPAND
ASSEMBLE
	CON(5)	=DOCODE
	REL(5)	endDoLabel
RPL
ASSEMBLE
	STITLE	DoLabel Replacement v0.4
**** Data ALLOCation *********************************************************
	DSECT	Dolabel,0		Start from even page (0-offset)
* Allocate memory for variables:
	MALLOC	STbits,5		saved ST register for RPL EVAL
	MALLOC	Sft1,5			saved @ of begin of HARDBUFF2
	MALLOC	Font,5			saved @ of font
	MALLOC	LoopCntr,1		loop counter for 1 to 6 menu keys
* "above" ONLY is saved during call to =grob (ie 16 nibs)
	MALLOC  MenuType,1		menu label grob type
	MALLOC	write@,5		saved write @ around write$
	MALLOC	charaddr,60

	IFPOS	(curpos)-#F1
	  MESSAGE  IRAMBUFF overflow!
	ENDIF

**** ST status flags *********************************************************
** NOTE: flags 0,1 used by =grob!

** flags that are specific to a menu key
*s		EQU	0
sDoRTN		EQU	0		SET = do a RTN after CHARLOOP (Status)
sInvert		EQU	1		SET = invert menu key
sDIR		EQU	2		SET = This menu key is a DIR label
sBLANK		EQU	3		SET = blank menu key

** flags that we need to save between menu keys
sPORT		EQU	4		SET = port menu on GX
sSOLV		EQU	5		SET = Solver menu displayed
sMATH		EQU	6		SET = SuperMenu displayed
sOVAL		EQU	7		SET = oval menu displayed
sEVEN		EQU	8		SET = menu label on even address
sGX		EQU	9		SET = on a G/GX machine
sGARBAGE	EQU	10		SET = garbage already occurred
	
**** Main ********************************************************************
	GOSBVL	=SAVPTR
	CLRST
	GOSUBL	InitBuff
* Now determine which menu system we are using
	D0=(5)	(=DoLabel)+7
	A=DAT0	A		A.A is jump through address
	D0=A
	A=DAT0	A		A.A is now address of menu dispatchee
	LC(5)	=StdLabelDef	#3A260
	?A#C	A
	GOYES	p1
	GOTO	StdMenus!
p1	LC(4)	=SuperLblDef	#3F040
	?A#C	A
	GOYES	p2
	ST=1	sMATH
	GOTO	SuperMenus!
p2	LC(3)	=PortMenuDef	#3F5F7
	?A#C	A
	GOYES	p3
	ST=1	sPORT
	GOTO	PortMenu!
p3	LC(5)	=SolvrLblDef	#1548C
	?A#C	A
	GOYES	p4
	ST=1	sSOLV
	GOTO	SolvrMenu!
* None of the above => must be MES on GX or user/lib defined (needs abs. addr)
p4	GOSBVL	=GETPTR		restore regs
	LA(5)	=DispMenu.1	PC=(A) needs prolog in A.A
	PC=(A)			jump to ROM version of menu update routine
** PLEASE DO NOT REMOVE THIS NEXT LINE !
	NIBASC	/R.H.Steventon/
**** SuperMenus! *************************************************************
* Algorithm	: DUPNULL$? ITE MakeStdLabel MakeDirLabel
SuperMenus!
	GOSUBL	Def->D0
	GOSUB	size->#chars	point to prolog, get # chars into C.A
	?C=0	A		zero length obj ?
	GOYES	SuperM1
	ST=1	sDIR		Mark as DirLabel
SuperM1	GOTO	DoKey

**** SolvrMenu! **************************************************************
* Algorithm	: DUPTYPEIDNT? OVER NULL$ EQUALOR (null$ or id -> invert key)
*		  NOTcase >Menu			  (not, so do normal menu)
*		  DUPTYPEIDNT? IT ID>$		  (if id, --> $ then display)
* 		  MakeInvlabel Grob>Menu	  (.. as an inverted menu key)
SolvrMenu!
	GOSUBL	Def->D0
	C=DAT0	A		get object prolog
	LA(5)	=DOIDNT
	?C#A	A		is it id ?
	GOYES	Solv1
* it is an id
	D0=D0+	5		point to size
	C=0	A
	C=DAT0	B		C.A is obj. length field
	D0=D0+	2		!!! id size field is 2 Nibs !!!
	ST=1	sInvert		INVERT THIS KEY !
	GOTO	Dolab1
Solv1	LA(5)	=DOCSTR
	?C#A	A		not a string?
	GOYES	NotSolv
	GOSUB	size->#chars	point to prolog, get # chars into C.A
	?C=0	A
	GOYES	Solv2		yes, it is a zero length string!
	GOTO	notblank
* Here 	D0  = @ size
*	C.A = number of chars
Solv2	ST=1	sInvert		set Inverted (white) key
	GOTO	blank		Set as blank key

**** StdMenus! ***************************************************************
*  Algorithm	: CK&DISPATCH0
*		  str   :: MakeStdlabel Grob>Menu ;
*		  id    :: DUP ID>$ SWAP @ ITE		( Exists? )
*			   :: TYPERRP? ITE		( and dir? then DIR)
*			      MakeDirlabel MakeStdlabel ;
*			   MakeStdlabel			( no, do default )
*			   Grob>Menu			( whatever, disp. it)
*			   ;
*			 ;
*  		  grob  Grob>Menu
*		  seco  :: EVAL Dolabel ;

StdMenus!
	GOSUBL	Def->D0		D0:Menu Label adress
StdMenu	C=DAT0	A		get object prolog
NotSolv	LA(5)	=DOCSTR
	?C#A	A
	GOYES	Std1
	GOSUB	size->#chars	it is $, get size and do menu type
	GOTO	DoKey
Std1	LA(5)	=DOIDNT
	?C=A	A
	GOYES	IsID
	GOTO	CKgrb/seco
********
IsID	CD0EX
	R3=C.F	A		Save address of object in R3
	C=C+CON	A,5
	R0=C			R0 = id name form
	?ST=1	=sGX
	GOYES	IsIDgx
	D0=(5)	=CONTEXT
	C=DAT0	A
	R1=C.F	A		R1 = rrp (sx)
	GOSBVL	=RAMFIND
	GOTO	IsIDsx
IsIDgx	D0=(5)	=G_CONTEXT
	C=DAT0	A
	R1=C.F	A		R1 = rrp (gx)
	GOSBVL	=G_RAMFIND
IsIDsx	GOC	IsIDnF		CS if it is NOT found!!
	GOTO	hereblw
IsIDnF  GOTO	IsIDnF2	
hereblw	A=DAT0	A		
	LC(5)	=DORRP
	?A#C	A
	GOYES	TypeCase
	ST=1	=sDIR		flag it as a dir label
	GOTO	IsIDnF
***** Check which object type is the ID  found
TypeCase
	LC(5)	=DOCSTR		String?
	?A#C	A
	GOYES	nostr
	GOTO	isstr
nostr	LC(5)	=DOCHAR		Char?
	?A#C	A
	GOYES	nochar
isstr	LC(5)	2		String!
	GOTO	endtype

nochar	LC(5)	=DOARRY		Array?
	?A#C	A
	GOYES	noarry
	LC(5)	3		Array!
	ST=1	sInvert		Inverted key
	GOTO	endtype

noarry	LC(5)	=DOLIST		List?
	?A#C	A
	GOYES	nolist
	LC(5)	4		List!
	ST=1	sInvert
	GOTO	endtype
	
nolist	LC(5)	=DOIDNT		Global name?
	?A#C	A
	GOYES	noidnt
	GOTO	issymb
noidnt	LC(5)	=DOSYMB		Algebraic?
	?A#C	A
	GOYES	nosymb
issymb	LC(5)	5		Symbolic thingie!
	ST=1	sInvert
	GOTO	endtype

nosymb	LC(5)	=DOCOL		Secondary?
	?A#C	A		
	GOYES	nocol
	GOTO	isprg
nocol	LC(5)	=DOCODE		Code?
	?A#C	A
	GOYES	nocode
isprg	LC(5)	6		Program!
	GOTO	endtype

nocode	LC(5)	=DOGROB		Graphic Object?
	?A#C	A
	GOYES	nogrob
	LC(5)	7		Grob!
	ST=1	sInvert
	GOTO	endtype

nogrob	LC(5)	=DOLIB		Library?
	?A#C	A
	GOYES	nolibr
	GOTO	islib
nolibr  LC(5)	=DOEXT0		Library Data?
	?A#C	A
	GOYES	noext
islib	LC(5)	8		Lib!
	ST=1	sInvert
	GOTO	endtype

noext	LC(5)	1		Must be Real/Complex/Bint
	ST=1	sInvert
* now store the menu tupe in C in RAMBUFF
endtype	A=R4.F	A		Retrieve IRAMBUFF @
	D0=A
	D0=(2)	=MenuType	Point to MenuType nibble
	DAT0=C	1		Store C there
	
* Not Found (but is an ID) or Found (but not a DIR)
IsIDnF2	C=R3.F	A
	D1=C
	D1=D1+	5		point to length field
	C=0	A
	C=DAT1	B
	D1=D1+	2		point to char data
	GOTO	Dolab2
********
CKgrb/seco
	LA(5)	=DOGROB
	?C#A	A		not a Grob, then presume it is a Seco
	GOYES	Seco!
	GOTO	IsGrob!
********
Seco!
** Not a 21 x 8 Grob or a $ or ID
** A.A is prolog, D0 -> Def
** Presume it is a DOCOL and do an RPL EVAL of it
** NOTE : WILL NEED TO POP FONT ADDRESS AFTERWARDS, 'cos it Might change on GX

** Note2: If the first RPL word is DirLabel: then we can handle it ourselves.
   
	LA(5)	=DirLabel:
	D0=D0+	5		First RPL word
	C=DAT0	A
	?C#A	A		Is it DirLabel: ?
	GOYES	+
	D0=D0+	5		This better point to a $ or else!
	GOSUB	size->#chars
	ST=1	sDIR		Mark it as a DirLabel
	GOTO	DoKey
+
	D0=D0-	5
	AD0EX			save address in A
	GOSBVL	=GETPTR
	ST=0	=sGARBAGE
nn8	D=D-1	A		memory left ?
	GOC	memout
	D1=D1-	5		make space on stack
	DAT1=A	A		write address
	GOTO	nn7
memout
	?ST=1	=sGARBAGE
	GOYES	MemERR
	GOSUB	DoRPL
	CON(5)	=DOCOL
RPL
*	SHALT
	GARBAGE
	COLA
ASSEMBLE
	CON(5)	=DOCODE
	REL(5)	endDoLabel
	ST=1	sGARBAGE	flag GC ALREADY occurred
	GOSBVL	=SAVPTR
	GOTO	nn8
DoRPL	C=RSTK			pop addr of embedded RPL ob
	A=C	A
	PC=(A)			start RPL
**** Memory Error ************************************************************
MemERR	LA(5)	=SETMEMERR
	PC=(A)
** Now jump to RPL and EVAL the Object
nn7	CD0EX
	RSTK=C			save D0
	C=R4.F	A
	D0=C
	D0=(2)	=STbits
	C=ST
	DAT0=C	A		save ST reg
* Now save IRAMBUFF vars in buffer$
* stk: font, buffer$, pushed ob
	D1=D1+	5		point to stk 2
	C=DAT1	A		get addr of buffer$
	D1=D1-	5		restore D1
	D0=(2)	=Dolabel
	A=DAT0	W
	D0=C
	D0=D0+	10
	DAT0=A	W
	C=RSTK
	D0=C			restore D0
	GOSUB	DoRPL
	CON(5)	=DOCOL
RPL
*	SHALT
	EVAL
	COLA
ASSEMBLE
	CON(5)	=DOCODE
	REL(5)	endDoLabel
*	A=DAT1	A
*	D1=D1+	5		point to font
*	D=D+1	A		pop ob
	GOSBVL	=PopASavptr
	B=A	A
** Restore IRAM address
	D0=(5)	(=IRAM@)-4
	C=DAT0	A
	LC(4)	#0100
	R4=C.F	A		save in R4.A
	D0=C			d0 = IRAMbuff
	A=DAT1	A		A.A = string addr
	C=0	A
	LC(1)	10
	A=A+C	A		A.A = string addr
	AD0EX			A.A = @ IRAMBUFF,  D0 = $ addr
	C=DAT0	W		get old IRAMBUFF
	D0=A
	DAT0=C	W		restore it
* Update font address (in case we are in TEMPOB and we moved during EVAL)_
	D0=(2)	=Font
	D1=D1+	5		point to font
	C=DAT1	A		get font addr
*	A=0	A
*	LA(1)	10
	C=C+CON	A,10
	DAT0=C	A		update font address in case it moved due to GC
	D0=(2)	=STbits
	C=DAT0	A		saved ST reg
	ST=C
	C=B	A
	D0=C			D0 = addr of EVAL'ed ob
	GOTO	StdMenu
********
IsGrob!
** It is a grob, D0 points to prolog
	CD0EX
	D=C	A		save addr of grob in D.A
	GOSBVL	=D1=DSKTOP	D1 = addr STK1
* NOTE: =grob! uses IRAM, so save it in the $ on the stack
	C=R4.F	A
	RSTK=C			save IRAM
	D0=C			D0 = IRAM
	A=C	A		save copy of IRAM in A for later
	C=DAT1	A
	D1=C
	D1=D1+	10		point to string data
	C=DAT0	W		read
	DAT1=C	W		write
* use copy of IRAM
	AD1EX
* get the loop counter
	D1=(2)	=LoopCntr
	C=0	A
	C=DAT1	1
	C=C-1	B		option base 0
	B=C	B
* restore D0
	C=D	A
	D0=C			restore D0
* now calculate X,Y co-ordinates
	A=0	A
	R0=A.F	A		x co-ord. = zero
	LC(2)	22
	A=A-C	B		trap zero offset
ntlp	A=A+C	B
	B=B-1	B
	GONC	ntlp
	R1=A.F	A		y co-ord

	D1=(2)	=Sft1
	C=DAT1	A		@ first nib
	LA(5)	20
	C=C-A	A		@ prolog
	D1=C
* D0 = source (prolog)
* D1 = target (prolog)
* R0,R1 = x, y co-ord's
	GOSBVL	=grob!		Trashes *EVERYTHING* , 3 stack levels
	GOSBVL	=D1=DSKTOP
	C=RSTK
	R4=C.F	A		restore IRAM
* Now restore IRAM
	A=DAT1	A		A.A is addr STK1 (string)
	D1=C			D1 = IRAM
	D0=A			D0 = $
	D0=D0+	10		D0 = $ data (IRAM copy)
	C=DAT0	W
	DAT1=C	W
* Now we have to FLOSS the menu key (yes, just like your teeth!)
	D1=(2)	=LoopCntr
	C=0	A
	C=DAT1	1		get loop counter (1...6 for menu key 1->6)
	D1=(2)	=Sft1
	A=DAT1	A
	GOTO	fnx
fnx1	A=A+CON	A,6
fnx	C=C-1	B
	GONC	fmenu
	A=A-1	A
	D0=A			D0 = write addr
	LA(3)	#707
lpp1	C=DAT0	1
	C=C&A	P
	DAT0=C	1
	D0=D0+	16
	D0=D0+	16
	D0=D0+	2
	A=A-1	XS
	GONC	lpp1
	ST=0	sDoRTN		Don't do a RTN or we will crash
	GOTO	After$
fmenu	A=A+CON	A,5
	C=C-1	B
	GONC	fnx1
	D0=A			D0 = write addr
	LA(3)	#70D
	GOTO	lpp1

**** PortMenu! ***************************************************************
* Algorithm	: DTYPECSTR? ITE MakeStdLabel
*		  :: #:>$ $ ":" SWAP &$ MakeDirLabel ; Grob>Menu
*		  Done late at night without a GX to test on...
PortMenu!
	GOSUBL	Def->D0
	C=DAT0	A
	LA(5)	=DOCSTR
	?A#C	A		not a string ?
	GOYES	PM1
	GOSUB	size->#chars	it is string, so dispatch to normal key
	GOTO	DoKey
PM1	ST=1	sDIR
	D0=D0+	5
	C=DAT0	A		get #
	CD1EX			Save # in D1
** we need some space to make the string
	GOSBVL	=D0=DSKTOP
	C=DAT0	A
	D0=C
	D=C	A		save write address - 10
	D0=D0+	10
	LAASC	/:/
	DAT0=A	B
	D0=D0+	2
	AD1EX			a.a is bint
* D.W is safe through this call (it takes a hex number in A.A and writes
*                                its ascii representation to space at D0)
	GOSBVL	=#>DEC		a.a is bint, D0 = space --> 1st nib beyond
	LCASC	/:/
	DAT0=C	B
	D0=D0-	12		minus 10 (prolog) minus 2 (2 nibs past write)
	AD0EX
	C=D	A
	A=A-C	A
	ASRB.F	A		A.A is number of chars written - 2
	A=A+CON	A,2
	C=D	A
	C=C+CON	A,10
	D1=C
	C=A	A
	GOTO	Dolab2

**** size->#chars ************************************************************
* ENTRY	: D0  = address of prolog
* EXIT	: C.A = number of chars
*	: D0  = address of size
size->#chars
	D0=D0+	5		point to size
	C=DAT0	A		C.A is obj. length field
	C=C-CON	A,5		sub length field size
	CSRB.F	A		div 2
	RTN

**** DoKey *******************************************************************
* D0 = @ size
* C.A = number of chars
* check if C=0, then set sBLANK
DoKey	?C#0	A
	GOYES	notblank
blank	ST=1	sBLANK
notblank
	D0=D0+	5		point past size to data
Dolab1	AD0EX
	D1=A
Dolab2	D=C	A		put size in D
* D.A = number of chars in string
* D1  = @ first char
**** ShowLabel ****************************************************************
**
** Entry :	ST flags determine width
**		D.A = length of string
**		D1  = @ first nib data
*******************************************************************************
ShowLabel
	C=R4.F	A
	D0=C
	D0=(2)	=LoopCntr
	C=0	A
	C=DAT0	1		C.A = loop counter
	D0=(2)	=Sft1
	A=DAT0	A		A.A = @ HARDBUFF2
	C=C-1	B		option base 0
	GOTO	nx
nx1	A=A+CON	A,6
nx	C=C-1	B
	GONC	menu2
	ST=1	sEVEN
	GOTO	menu!
menu2	A=A+CON	A,5
	C=C-1	B
	GONC	nx1
	ST=0	sEVEN
*	GOTO	menu!		fall through to menu!

**** menu! ********************************************************************
* ENTRY : A.A = write addr
*	  D1  = (reserved)
*	  D.A = (reserved)
menu!	C=R4.F	A
	D0=C
	D0=(2)	=write@
	DAT0=A	A		save write address
	D0=A			D0 = write address
	CD1EX
	R0=C.F	A		Save D1 in R0
	D1=C
** Let us check the Label Object Type
	C=R4.F	A		Retrieve Menu Type
	D1=C
	D1=(2)	=MenuType
	C=0	A
	C=DAT1	1		C = type of object in that menu label
	?C#0	A
	GOYES   special		not your typical label!
	GOTO	usualk
** dispatch the 'special' object in that label
special	LA(5)	1		Real/Complex/Bint
	?A#C	A
	GOYES	notone		No
	?ST=1	sEVEN		Yes!
	GOYES	Numevn0		
	GOTO	Numodd		Odd memory address
Numevn0	GOTO    Numevn		Even memory address
	
notone	LA(5)	2		String?
	?A#C	A
	GOYES	nottwo		No
	?ST=1	sEVEN		Yes!
	GOYES	Strevn0
	GOTO	Strodd
Strevn0 GOTO	Strevn
	
nottwo	LA(5)	3		Array?
	?A#C	A
	GOYES	notthr
	?ST=1	sEVEN
	GOYES	Arrevn0
	GOTO	Arrodd
Arrevn0 GOTO	Arrevn
	
notthr	LA(5)	4		List?
	?A#C	A
	GOYES	notfou
	?ST=1	sEVEN
	GOYES	Lisevn0
	GOTO	Lisodd
Lisevn0 GOTO	Lisevn
	
notfou	LA(5)	5		Algebraic?
	?A#C	A
	GOYES	notfiv
	?ST=1	sEVEN
	GOYES	Symevn0
	GOTO	Symodd
Symevn0 GOTO	Symevn
	
notfiv	LA(5)	6		Program?
	?A#C	A
	GOYES	notsix
	?ST=1	sEVEN
	GOYES	Prgevn0
	GOTO	Prgodd
Prgevn0 GOTO	Prgevn
	
notsix	LA(5)	7		Grob?
	?A#C	A
	GOYES	notsev
	?ST=1	sEVEN
	GOYES	Groevn0
	GOTO	Groodd
Groevn0 GOTO	Groevn

notsev	LA(5)	8		Grob?
	?A#C	A
	GOYES	usualk
	?ST=1	sEVEN
	GOYES	Libevn0
	GOTO	Libodd
Libevn0 GOTO	Libevn
				
usualk	?ST=0	sInvert		NOT white menu key ?
	GOYES	Nrm/Dir		Normal key/Directory
isSOLV	?ST=1	sEVEN
	GOYES	Sevn
	GOTO	SOLVodd
Sevn	GOTO	SOLVevn
Nrm/Dir	?ST=1	sEVEN
	GOYES	NDevn0
	GOTO	NDodd
NDevn0  GOTO	NDevn
******************************************************************************
* The first letter of each label (either E or O) refer to even/odd address
* on which the menu key grob resides (odd = need to shift data)
* Every label grob has 8 rows of pixels:
*  First NIBHEX:  1st row
*  Second NIBHEX: 2nd row
*  Third NIBHEX:  Rows 3-7
*  Fourth NIBHEX: Row 8
* Odd labels are just the Even ones left-shifted two bits 
Numevn	GOSUB	EWkey
	NIBHEX	CFFF70
	NIBHEX  200080
	NIBHEX	100001
	NIBHEX	100001
Numodd	GOSUB	OWkey
	NIBHEX	0FFFF1
	NIBHEX	800002
	NIBHEX	400004
	NIBHEX	400004
Strevn	GOSUB	EWkey
	NIBHEX	820820
	NIBHEX	EFFFF0
	NIBHEX	FFFFF1
	NIBHEX	EFFFF0
Strodd	GOSUB	OWkey
	NIBHEX	0A00A0
	NIBHEX  8FFFF3
	NIBHEX	CFFFF7
	NIBHEX	8FFFF3
Arrevn	GOSUB	EWkey
	NIBHEX	7000C1
	NIBHEX	100001
	NIBHEX	100001
	NIBHEX	100001
Arrodd	GOSUB	OWkey
	NIBHEX	C10007
	NIBHEX	400004
	NIBHEX	400004
	NIBHEX	400004
Lisevn	GOSUB	EWkey
	NIBHEX	6000C0
	NIBHEX	100001
	NIBHEX	100001
	NIBHEX	100001
Lisodd	GOSUB	OWkey
	NIBHEX	810003
	NIBHEX	400004
	NIBHEX	400004
	NIBHEX	400004
Symevn	GOSUB	EWkey
	NIBHEX	FFFFF1
	NIBHEX	100001
	NIBHEX	100001
	NIBHEX	100001
Symodd	GOSUB	OWkey
	NIBHEX	CFFFF7
	NIBHEX	400004
	NIBHEX	400004
	NIBHEX	400004
Prgevn	GOSUB	EWkey
	NIBHEX	000000
	NIBHEX	EFFFF0
	NIBHEX	FFFFF1
	NIBHEX	EFFFF0
Prgodd	GOSUB	OWkey
	NIBHEX	000000
	NIBHEX	8FFFF3
	NIBHEX	CFFFF7
	NIBHEX	8FFFF3
Groevn	GOSUB	EWkey
	NIBHEX	AAAAA0
	NIBHEX	100001
	NIBHEX	100001
	NIBHEX	100001
Groodd	GOSUB	OWkey
	NIBHEX	8AAAA2
	NIBHEX	400004
	NIBHEX	400004
	NIBHEX	400004
Libevn	GOSUB	EWkey
	NIBHEX	FFFFF1
	NIBHEX	100001
	NIBHEX	100001
	NIBHEX	FFFFF1
Libodd	GOSUB	OWkey
	NIBHEX	CFFFF7
	NIBHEX	400004
	NIBHEX	400004
	NIBHEX	CFFFF7
NDevn	?ST=0	sDIR
	GOYES	EStdKey
EDirKey	GOSUB	EWkey
	NIBHEX	E30000
	NIBHEX	FFFFFD
	NIBHEX	FFFFFD
	NIBHEX	FFFFFD
EStdKey	GOSUB	EWkey
	NIBHEX	000000
	NIBHEX	FFFFFD
	NIBHEX	FFFFFD
	NIBHEX	FFFFFD
NDodd	?ST=0	sDIR
	GOYES	OStdKey
ODirKey	GOSUB	OWkey
	NIBHEX	8F0000
	NIBHEX	CFFFF7
	NIBHEX	CFFFF7
	NIBHEX	CFFFF7
OStdKey	GOSUB	OWkey
	NIBHEX	000000
	NIBHEX	CFFFF7
	NIBHEX	CFFFF7
	NIBHEX	CFFFF7
SOLVevn	GOSUB	EWkey		even menu key, Invert
	NIBHEX	FFFFF1
	NIBHEX	100001
	NIBHEX	100001
	NIBHEX	FFFFF1
SOLVodd	GOSUB	OWkey		odd menu key, Invert
	NIBHEX	CFFFF7
	NIBHEX	400004
	NIBHEX	400004
	NIBHEX	CFFFF7
**** Even menu key sub-routine ************************************************
EWkey	C=RSTK
	D1=C			D1 = data address
	P=	6-1
	C=DAT1	WP		read 6 nibs (1st Line of Grob)
	DAT0=C	WP		write first line
	GOSUB	ENxtLine	point to next line on screen
	D1=D1+	6		point to next line of data to read
	C=DAT1	WP		read 6 nibs (2nd Line of Grob)
	DAT0=C  WP		write second line
	GOSUB	ENxtLine	point to next line on screen
	D1=D1+	6		point to next line of data to read
	LA(1)	8-1-3		5 lines to read & write
	C=DAT1	WP		all the same, so get data
ELp	DAT0=C	WP		write data
	GOSUB	ENxtLine	point to next line
	A=A-1	P		dec. loop counter
	GONC	ELp
	D1=D1+	6		next read address (last line of Grob)
	C=DAT1	WP		read/
	DAT0=C	WP		     write last line
	P=	0
	GOTO	Write$
**** Even menu key sub-routine ***********************************************
ENxtLine
	D0=D0+	16
	D0=D0+	16
	D0=D0+	2
	RTN
***** Odd address menu key routines for writing the blank key ****************
OWkey	C=RSTK			get addr of data
	D1=C
	GOSUB	Fnib		mask & write first nib, incr D1,D0
	C=DAT1	A		read/write rest of line
	DAT0=C	A
	GOSUB	ONxtLine	next write line
	D1=D1+	5		next read line
	GOSUB	Fnib
	C=DAT1	A
	DAT0=C	A
	GOSUB	ONxtLine
	D1=D1+	5
	LA(1)	6-2		5 lines to write
	B=A	P		loop counter in B
OLp	GOSUB	Fnib		mask first nib
	C=DAT1	A		read/
	DAT0=C	A		     write rest of line
	GOSUB	ONxtLine	point to next line
	D1=D1-	1		back up read address
	B=B-1	P		dec. loop counter
	GONC	OLp		if CS then finished middle... now do last row
	D1=D1+	6		incr. read counter
	GOSUB	Fnib		mask & write first nib
	C=DAT1	A		rest of line
	DAT0=C	A
	GOTO	Write$		write string into display
**** Odd address menu key D0-->Next line *************************************
ONxtLine
	D0=D0+	16
	D0=D0+	16
	D0=D0+	1
	RTN
**** Odd address menu key mask routine ***************************************
* Algorithm	: we want 2 bits of info from the screen and 2 bits from the
*		: menukey data.
*		: So, get screen data, mask out what we don't want and OR
*		: it with menukey data (already masked).
Fnib	C=DAT0	P		get nib
	LA(1)	#3		mask
	C=C&A	P		get rid of what we don't want
	A=DAT1	P		get what we do want
	C=C!A	P		OR the two together
	DAT0=C	P		write back
	D1=D1+	1
	D0=D0+	1
	RTN
*** Def->D0 ******************************************************************
* Description	: returns the addr. of the display part of the menu key in D0
* ENTRY 	: any
* EXIT  	: D0 = @ definition for that row
* USES  	: A.A, C.A, D.A, D0,
******************************************************************************
Def->D0
** First, get the row number
	A=R4.F	A
	D0=A
	D0=(2)	=LoopCntr
	C=0	A
	C=DAT0	1		C.A is row number
** Now get the address of the thingie to show
	?ST=1	=sGX
	GOYES	getdfgx
	D0=(5)	=TOUCHTAB
	GOTO	getdfsx
getdfgx	D0=(5)	=G_TOUCHTAB
getdfsx A=DAT0  A
        D0=A                    D0 -> Touch Table
        D0=D0+  3               D0 -> Display Function Part
        AD0EX                   A[A] -> Display Function Part
	C=C-1   A               C[A] = N-1 (Row number-1)
	D=C     A
	C=C+C   A
	C=C+C   A
	C=C+D   A               C[A] = 5(N-1)
	A=A+C   A               A[A] -> slot
	D0=A                    D0 -> slot
        A=DAT0  A               A[A] -> object
	D0=A
        RTN
******************************************************************************
**		D.A = length of string
**		R0  = @ first nib data
** save maximum width
Write$
	?D#0	B		check for zero length to write
	GOYES	notnull
	ST=0	sDoRTN
	GOTO	After$
notnull	C=R0.F	A
	D1=C
*	LC(5)	18/4
*	?ST=1	sInvert
*	GOYES	inv1
*	LC(2)	20/4
	LC(5)	5
inv1	B=C	A
	R0=C.F	A		max width
** save addr of font
	C=R4.F	A
	D0=C
	D0=(2)	=Font
	C=DAT0	A
	R2=C.F	A
** save addr of iram buffer (charaddr)
	D0=(2)	=charaddr
	CD0EX
	R3=C.F	A
	D0=C
*************************************************************
* Here:
*	R0 : max width		(used again)
*	R2 : @ Font (offset table)
*	R3 : @ IRAMBUFF data
*	R4 : IRAM BUFF START
*	A.A :
*	B.A : max width
*	C.A :
*	D.A : len$
*	D0 :
*	D1 : -> 1st chr

** compute the width of the string to display

	C=0	A		zero # of chars to write length

* Now we grab each char's width and calc the width & number of chars that fit
* D.A = number of chars left
* B.A = max width - width of chars so far
* C.A = number of chars so far that it is okay to write

cntlp
	D=D-1	A		Still chars to do ?
	GOC	done		will grab C.A as # of chars
	D0=C			save C

	C=R2.F	A		get addr of font
	A=0	A
	A=DAT1	B		A=000(ascii char)
	A=A+A	A
	C=C+A	A
	A=A+A	A
	C=C+A	A		c = c + 6*A		c = char @
*	CD0EX			D0 = char @,   C.A = # of chars so far
*	A=0	A
*	A=DAT0	4		get offset from this addr to data
*	CD0EX			D0 = number of chars so far

*	C=C+A	A		4 nibs !

	A=R3.F	A		get IRAMBUFF (current)
	AD0EX			save D0	in A
	DAT0=C	A		write char data addr
	D0=D0+	5		incr to next slot
	C=A	A
	AD0EX			restore D0, put addr of next slot in A.A
	R3=A.F	A		save Addr of next slot

*	CD0EX			D0 = @ size,bitmap data; C.A = # of chars
*	A=0	A
*	A=DAT0	1		get width (1 nib)

	B=B-1	A
	GOC	overdone
	C=C+1	A		that char fitted... go check next one
	D1=D1+	2		point to next char in $
	GOTO	cntlp
overdone
	B=B+1	A		B = max. width - actual width
done	D=C	A		D = # chars that fit

*****************************************************
* Here:
*	B[A]	limit - width
*	D[A]	# chars that fit
*	R0[A]	limit
*	R1[A]	-> $
*	R2[A]	address of font
*	R3[A]	IRAMBUFF data addr
*	R4[A]
* Now get starting offset, then do $->3x5 replacement
*****************************************************
	A=R0.F	A		Get limit
	A=A-B	A		A = width
	A=A+1	A		A = width+1
	SB=0
	ASRB.F	A		A= (width+1)/2
	ST=0	11
	?SB=0
	GOYES	+
*	A=A+1	A
	ST=1	11
+	LC(5)	3	11	point to center around (x)
	C=C-A	A		C= x-(width+1)/2 = x'
	GONC	centerxok
	C=0	A		fix width > 2*x
centerxok
	B=C	A
** Fix width to shift over
	C=R4.F	A
	D1=C
	D1=(2)	=LoopCntr
	A=0	A
	A=DAT1	1		C.A = loop counter
	ST=0	12
	A=A-1	B		option base 0
	?ABIT=0	0
	GOYES	+
	ST=1	12
+	LC(5)	5	22/4
ex2	A=A-1	B
	GOC	ex1
	B=B+C	A
	?ABIT=0	0
	GOYES	ex2
	B=B+1	A
	GOTO	ex2
ex1
** put write addr in D1
	D1=(2)	=Sft1
	A=DAT1	A
	LC(5)	34*2		34 nibs per line, 2 lines down
	C=C+A	A
	AD1EX			save IRAMBUFF in A.A
	D1=C			write addr
** read addr of string addresses in buffer
	LA(2)	=charaddr
	A=A-CON	A,5
	D0=A
	ST=0	sDoRTN
*	GOTO	CHARLOOP
******************************************************************************
* ENTRY : RSTK 	=
*	: D.A	= # number of chars to write
*	: B.A	= # of columns to shift over
*	: D0	= address of pointer to first char data - 5
*	: D1	= write @
*
* EXIT	: String written... NO CHECKS DONE !!!!!!!
******************************************************************************
CHARLOOP
	D=D-1	A			decrement character count
	GONC	char1			GOC was out of range
	GOTO	After$			CS when out of characters

** Compute the address of appropriate bit battern.
char1	D0=D0+	5			D0:address next character data
	C=DAT0	A
	CD0EX				D0:
	RSTK=C				save address of BUFFER

** Compute tracking nibble and write destination.
*	A=B	A			C[A]:total pixel columns
*	A=0	S			A[S]:intialized tracking
*	SB=0
*	ASRB.F	A
*	?SB=0
*	GOYES	divide2
*	A=A+1	S			not div. by 2 so shove in extra bit
*	SB=0
*divide2	ASRB.F	A
*	?SB=0				divisible by 4?
*	GOYES	savdisp
*	A=A+1	S			no, shove in 2 extra bits
*	A=A+1	S
savdisp	CD1EX
	RSTK=C				put addr to write to in RSTK
*	C=C+A	A
	C=C+B	A
	D1=C				d1 is addr to write to

** Determine whether or not font will fit on remaining grob.
*	A=0	A
*	LA(1)	4
*	A=DAT0	1			A[A]:pixel width of font
*	B=B+A	A			B[A]:total pixel columns
	B=B+1	A
** Compute the MSB bits for mask.
*	A=A+CON	B,13	9+4		A[B]:initialized counter
*	LC(3)	#FF			C[0-11]:[0000|1111|1111]
*rtshft1	CSRB.F	B	<---
*	A=A+1	P	    |		compute MSB bits of mask
*	GONC	rtshft1	 ---

	LC(3)	#1E
	?ST=0	12
	GOYES	+
	LC(2)	#78
+	?ST=0	11
	GOYES	+
	D1=D1-	1
	LC(3)	#1E0
+	R1=C.F	X

** Initilize final loop paramaters.
*	D0=D0+	1			point to char data
	P=	16-6

** Write loop for bit pattern-to-grob.
* P    = 16 - number of chars still to do
* D0   = @ char data
* D1   = write addr
* R1.X = mask
*
** Write loop for bit pattern-to-grob.
PIXLOOP	C=0	X	<-----------			     [ 6]
	C=DAT0	1		    |	get 2 nibs data      [15]
	A=R1.F	X		    |			     [ 9]

	C=C+C	X
	?ST=0	12
	GOYES	+
	C=C+C	X
	C=C+C	X
+	?ST=0	11
	GOYES	+
	C=C+C	X
	C=C+C	X
+

*	C=A	S		    |			     [ 4]
*	C=C-1	S		    |			     [ 4]
*	GOC	setbyte		    |			[10]/[ 3]
*rtshft2	A=A+A	X	<---	    |			     [ 6]
*	C=C+C	X	    |	    |	shift grob data left [ 6]
*	C=C-1	S	    |	    |			     [ 4]
*	GONC	rtshft2	 ---	    |			[10]/[ 3]
*setbyte
	?ST=0	sInvert
	GOYES	NormK
** this is for writing to a white/grey area
	A=-A-1	X		    |	A[B]:bit mask	     [ 6]
	RSTK=C			    |	RSTK:new bits	     [ 8]
	C=DAT1	X		    |	C[A]:old bits	     [20]
	A=A&C	X		    |	clears pixels	     [ 7]
	C=RSTK			    |	get pixel row	     [ 8]
	C=C!A	X		    |	add pixel row	     [ 7]
	A=DAT1	X			read screen data
	C=C!A	X			OR with pixel data
	GOTO	ANK
** this is for writing to a "black" area
NormK	A=DAT1	X
	C=-C-1	X
	C=C&A	X
ANK	DAT1=C	X		    |	set pixel row	     [19]
	D1=D1+	16
	D1=D1+	16
	D1=D1+	2
	D0=D0+	1		    |			     [ 7]
	P=P+1			    |			     [ 3]
	GONC	PIXLOOP	----------->			[10]/[ 3]
** Reset pointer registers for next character.
	C=RSTK
	D1=C
	C=RSTK
	D0=C
	GOTO	CHARLOOP
******************************************************************************
** end CHARLOOP **************************************************************

******************************************************************************
* After string written to display, check for oval display, do housekeeping
* and restart on next menu key
After$
* Set Menu Type to zero for next iteration
	LC(5)	0
	A=R4.F	A
	D1=A
	D1=(2)	=MenuType
	DAT1=C	A
* Check if we make menus oval....
	?ST=1	sDoRTN		these next two lines are do a RTN if the
	RTNYES			code is used by $>grob or DispStatus
	?ST=1	sOVAL
	GOYES	Ovals!
	GOTO	noOval
* Display Oval Menus
Ovals!	C=R4.F	A
	D0=C
	D0=(2)	=LoopCntr
	C=0	A
	C=DAT0	1
	C=C-1	P		option base 0
	D0=(2)	=Sft1
	A=DAT0	A
	GOTO	nnx
nnx1	A=A+CON	A,6
nnx	C=C-1	P
	GONC	nmenu
* even
	?ST=1	sInvert
	GOYES	ea1
* invert menu key, so invert the TOP line (as opposed to 2nd line down)
	LC(5)	34
	A=A+C	A
ea1	D0=A
	GOTO	k1
nmenu	A=A+CON	A,5
	C=C-1	P
	GONC	nnx1
* odd
	?ST=1	sInvert
	GOYES	ea2
	LC(5)	34
	A=A+C	A
ea2	D0=A
	GOTO	k2
*************************
noOval
* clear all unwanted bits in ST register
	C=ST			get bits
	LA(3)	#3F0		mask
	C=C&A	X		and with mask to kill unwanted bits
	ST=C			write bits
	C=R4.F	A
	D0=C
	D0=(2)	=LoopCntr
	C=0	A
	C=DAT0	1
	LA(2)	6
	?A=C	B
	GOYES	exit
	C=C+1	A
	DAT0=C	1
	?ST=0	sSOLV
	GOYES	NoSlv
	GOLONG	SolvrMenu!
NoSlv	?ST=0	sMATH
	GOYES	NoSup
	GOLONG	SuperMenus!
NoSup	?ST=0	sPORT
	GOYES	Std!
	GOLONG	PortMenu!
Std!	GOLONG	StdMenus!
exit	GOVLNG	=GETPTRLOOP

******************************************************************************
* oval menu key sub routines
k2	GOSUB	key2_sub
	?ST=1	sInvert
	GOYES	k20
	LA(5)	34*6-5
	GOTO	k21
k20	LA(5)	34*7-5
k21	CD0EX
	C=C+A	A
	D0=C
	GOSUB	key2_sub
	GOTO	noOval
***** OVAL MENU **********
k1	GOSUB	key1_sub
	?ST=1	sInvert
	GOYES	k10
	LA(5)	34*6-5
	GOTO	k11
k10	LA(5)	34*7-5
k11	CD0EX
	C=C+A	A
	D0=C
	GOSUB	key1_sub
	GOTO	noOval
key1_sub				write values for type 1
	C=DAT0	1
	CBIT=0	0
	DAT0=C	1
	D0=D0+	5
	C=DAT0	1
	CBIT=0	0
	DAT0=C	1
	RTN
key2_sub				write values for type 2
	C=DAT0	1
	CBIT=0	2
	DAT0=C	1
	D0=D0+	5
	C=DAT0	1
	CBIT=0	2
	DAT0=C	P
	RTN

**** InitBuff ****************************************************************
* Description	: Initiates the data buffer
* ENTRY		: after savptr,
* 		  STK2: Smallfont
*		  STK1: 16 nib buffer (temp copy of IRAM during RPL EVAL)
******************************************************************************
InitBuff
	D1=D1+	5		@ STK2
	C=DAT1	A
	LA(5)	5+5		5 nibs prolog + 5 nibs size
	C=C+A	A		@ of first nib data in font
* get machine independent IRAMBUFF address
	D0=(5)	(=IRAM@)-4
	A=DAT0	A
	LA(4)	#0100
	R4=A.F	A		save in R4.A
* Save @ of SmallFont
	D1=A			put data buffer @ in D0
	D1=(2)	=Font
	DAT1=C	A		save @ first nib of SmallFont in IRAMBUFF
** save loop counter ( 1 NIB )
	LC(5)	1
	D1=(2)	=LoopCntr
	DAT1=C	1
** save Menu Type initially to zero ( 1 NIB )
	LC(5)	0
	D1=(2)	=MenuType
	DAT1=C	1
		
** Test if GX or SX
** Assumes CLRST has been done
	D0=(5)	=IRAM@
	C=DAT0	B
	?CBIT=0	3
	GOYES	setsx
	ST=1	=sGX		GX
setsx
** Initialise HARDBUFF2 address
	GOSBVL	=D0->Sft1	D0, A.A = @ first nib of HARDBUFF2
	D1=(2)	=Sft1
	DAT1=A	A

	?ST=1	sGX
	GOYES	nMgx
	D1=(5)	#706E4
	GOTO	nMsx
nMgx	D1=(5)	#80862
nMsx	C=DAT1	1
	?CBIT=1	2		User flag 63 SET ? -> further tests
	GOYES	IOval
	GOTO	Iend
* now check if CST menu is displayed
IOval	ST=1	sOVAL
	?ST=1	sGX
	GOYES	gxcode
*sx code
	D0=(5)	#7061E
	C=DAT0	A
	LA(5)	#3B239
	?A#C	A
	GOYES	nocst
	GOTO	cst!		CST menu !
nocst	GOTO	Iend
gxcode	D0=(5)	#8079D
	C=DAT0	A		get pointer
	D0=C
	D0=D0+	5		point past prolog
	LAHEX	0010A9		xlib 169 1
	P=	6-1
	C=DAT0	WP
	?C=A	WP
	GOYES	cst!		CST menu!
	P=	0
	GOTO	Iend
cst!	P=	0
	C=DAT1	1
	?CBIT=0	1		User flag 62 CLEAR? -> force Ovals
	GOYES	Iend
	ST=0	sOVAL
Iend	RTN

******************************************************************************

ASSEMBLE
endDoLabel
RPL
 2DROP				( drop smallfont and Buffer$ )
 SetDA3Valid			( signal redraw menu bar )
;

]],[[

::
 DoFSTCALL(KeyInBuffer?)
 case SetDA3Bad		( no time to update, so signal bad )
 TURNMENUON
 DoFSTCALL(smallfont)
 NULL$ SIXTEEN EXPAND
ASSEMBLE
	CON(5)	=DOCODE
	REL(5)	endDoLabel
RPL
ASSEMBLE
	STITLE	DoLabel Replacement v0.4
**** Data ALLOCation *********************************************************
	DSECT	Dolabel,0		Start from even page (0-offset)
* Allocate memory for variables:
	MALLOC	STbits,5		saved ST register for RPL EVAL
	MALLOC	Sft1,5			saved @ of begin of HARDBUFF2
	MALLOC	Font,5			saved @ of font
	MALLOC	LoopCntr,1		loop counter for 1 to 6 menu keys
* "above" ONLY is saved during call to =grob (ie 16 nibs)
	MALLOC  MenuType,1		menu label grob type
	MALLOC	write@,5		saved write @ around write$
	MALLOC	charaddr,60

	IFPOS	(curpos)-#F1
	  MESSAGE  IRAMBUFF overflow!
	ENDIF

**** ST status flags *********************************************************
** NOTE: flags 0,1 used by =grob!

** flags that are specific to a menu key
*s		EQU	0
sDoRTN		EQU	0		SET = do a RTN after CHARLOOP (Status)
sInvert		EQU	1		SET = invert menu key
sDIR		EQU	2		SET = This menu key is a DIR label
sBLANK		EQU	3		SET = blank menu key

** flags that we need to save between menu keys
sPORT		EQU	4		SET = port menu on GX
sSOLV		EQU	5		SET = Solver menu displayed
sMATH		EQU	6		SET = SuperMenu displayed
sOVAL		EQU	7		SET = oval menu displayed
sEVEN		EQU	8		SET = menu label on even address
sGX		EQU	9		SET = on a G/GX machine
sGARBAGE	EQU	10		SET = garbage already occurred
	
**** Main ********************************************************************
	GOSBVL	=SAVPTR
	CLRST
	GOSUBL	InitBuff
* Now determine which menu system we are using
	D0=(5)	(=DoLabel)+7
	A=DAT0	A		A.A is jump through address
	D0=A
	A=DAT0	A		A.A is now address of menu dispatchee
	LC(5)	=StdLabelDef	#3A260
	?A#C	A
	GOYES	p1
	GOTO	StdMenus!
p1	LC(4)	=SuperLblDef	#3F040
	?A#C	A
	GOYES	p2
	ST=1	sMATH
	GOTO	SuperMenus!
p2	LC(3)	=PortMenuDef	#3F5F7
	?A#C	A
	GOYES	p3
	ST=1	sPORT
	GOTO	PortMenu!
p3	LC(5)	=SolvrLblDef	#1548C
	?A#C	A
	GOYES	p4
	ST=1	sSOLV
	GOTO	SolvrMenu!
* None of the above => must be MES on GX or user/lib defined (needs abs. addr)
p4	GOSBVL	=GETPTR		restore regs
	LA(5)	=DispMenu.1	PC=(A) needs prolog in A.A
	PC=(A)			jump to ROM version of menu update routine
** PLEASE DO NOT REMOVE THIS NEXT LINE !
	NIBASC	/R.H.Steventon/
**** SuperMenus! *************************************************************
* Algorithm	: DUPNULL$? ITE MakeStdLabel MakeDirLabel
SuperMenus!
	GOSUBL	Def->D0
	GOSUB	size->#chars	point to prolog, get # chars into C.A
	?C=0	A		zero length obj ?
	GOYES	SuperM1
	ST=1	sDIR		Mark as DirLabel
SuperM1	GOTO	DoKey

**** SolvrMenu! **************************************************************
* Algorithm	: DUPTYPEIDNT? OVER NULL$ EQUALOR (null$ or id -> invert key)
*		  NOTcase >Menu			  (not, so do normal menu)
*		  DUPTYPEIDNT? IT ID>$		  (if id, --> $ then display)
* 		  MakeInvlabel Grob>Menu	  (.. as an inverted menu key)
SolvrMenu!
	GOSUBL	Def->D0
	C=DAT0	A		get object prolog
	LA(5)	=DOIDNT
	?C#A	A		is it id ?
	GOYES	Solv1
* it is an id
	D0=D0+	5		point to size
	C=0	A
	C=DAT0	B		C.A is obj. length field
	D0=D0+	2		!!! id size field is 2 Nibs !!!
	ST=1	sInvert		INVERT THIS KEY !
	GOTO	Dolab1
Solv1	LA(5)	=DOCSTR
	?C#A	A		not a string?
	GOYES	NotSolv
	GOSUB	size->#chars	point to prolog, get # chars into C.A
	?C=0	A
	GOYES	Solv2		yes, it is a zero length string!
	GOTO	notblank
* Here 	D0  = @ size
*	C.A = number of chars
Solv2	ST=1	sInvert		set Inverted (white) key
	GOTO	blank		Set as blank key

**** StdMenus! ***************************************************************
*  Algorithm	: CK&DISPATCH0
*		  str   :: MakeStdlabel Grob>Menu ;
*		  id    :: DUP ID>$ SWAP @ ITE		( Exists? )
*			   :: TYPERRP? ITE		( and dir? then DIR)
*			      MakeDirlabel MakeStdlabel ;
*			   MakeStdlabel			( no, do default )
*			   Grob>Menu			( whatever, disp. it)
*			   ;
*			 ;
*  		  grob  Grob>Menu
*		  seco  :: EVAL Dolabel ;

StdMenus!
	GOSUBL	Def->D0
StdMenu	C=DAT0	A		get object prolog
NotSolv	LA(5)	=DOCSTR
	?C#A	A
	GOYES	Std1
	GOSUB	size->#chars	it is $, get size and do menu type
	GOTO	DoKey
Std1	LA(5)	=DOIDNT
	?C=A	A
	GOYES	IsID
	GOTO	CKgrb/seco
********
IsID	CD0EX
	R3=C.F	A		Save address of object in R3
	C=C+CON	A,5
	R0=C			R0 = id name form
	?ST=1	=sGX
	GOYES	IsIDgx
	D0=(5)	=CONTEXT
	C=DAT0	A
	R1=C.F	A		R1 = rrp (sx)
	GOSBVL	=RAMFIND
	GOTO	IsIDsx
IsIDgx	D0=(5)	=G_CONTEXT
	C=DAT0	A
	R1=C.F	A		R1 = rrp (gx)
	GOSBVL	=G_RAMFIND
IsIDsx	GOC	IsIDnF		CS if it is found
	A=DAT0	A
	LC(5)	=DORRP
	?A#C	A
	GOYES	IsIDnF
	ST=1	=sDIR		flag it as a dir label
* Not Found, but is an ID or Found, but not a DIR
IsIDnF	C=R3.F	A
	D1=C
	D1=D1+	5		point to length field
	C=0	A
	C=DAT1	B
	D1=D1+	2		point to char data
	GOTO	Dolab2
********
CKgrb/seco
	LA(5)	=DOGROB
	?C#A	A		not a Grob, then presume it is a Seco
	GOYES	Seco!
	GOTO	IsGrob!
********
Seco!
** Not a 21 x 8 Grob or a $ or ID
** A.A is prolog, D0 -> Def
** Presume it is a DOCOL and do an RPL EVAL of it
** NOTE : WILL NEED TO POP FONT ADDRESS AFTERWARDS, 'cos it Might change on GX
	AD0EX			save address in A
	GOSBVL	=GETPTR
	ST=0	=sGARBAGE
nn8	D=D-1	A		memory left ?
	GOC	memout
	D1=D1-	5		make space on stack
	DAT1=A	A		write address
	GOTO	nn7
memout
	?ST=1	=sGARBAGE
	GOYES	MemERR
	GOSUB	DoRPL
	CON(5)	=DOCOL
RPL
*	SHALT
	GARBAGE
	COLA
ASSEMBLE
	CON(5)	=DOCODE
	REL(5)	endDoLabel
	ST=1	sGARBAGE	flag GC ALREADY occurred
	GOSBVL	=SAVPTR
	GOTO	nn8
DoRPL	C=RSTK			pop addr of embedded RPL ob
	A=C	A
	PC=(A)			start RPL
**** Memory Error ************************************************************
MemERR	LA(5)	=SETMEMERR
	PC=(A)
** Now jump to RPL and EVAL the Object
nn7	CD0EX
	RSTK=C			save D0
	C=R4.F	A
	D0=C
	D0=(2)	=STbits
	C=ST
	DAT0=C	A		save ST reg
* Now save IRAMBUFF vars in buffer$
* stk: font, buffer$, pushed ob
	D1=D1+	5		point to stk 2
	C=DAT1	A		get addr of buffer$
	D1=D1-	5		restore D1
	D0=(2)	=Dolabel
	A=DAT0	W
	D0=C
	D0=D0+	10
	DAT0=A	W
	C=RSTK
	D0=C			restore D0
	GOSUB	DoRPL
	CON(5)	=DOCOL
RPL
*	SHALT
	EVAL
	COLA
ASSEMBLE
	CON(5)	=DOCODE
	REL(5)	endDoLabel
	A=DAT1	A
	D1=D1+	5		point to font
	D=D+1	A		pop ob
	GOSBVL	=SAVPTR
	B=A	A
** Restore IRAM address
	D0=(5)	(=IRAM@)-4
	C=DAT0	A
	LC(4)	#0100
	R4=C.F	A		save in R4.A
	D0=C			d0 = IRAMbuff
	A=DAT1	A		A.A = string addr
	LC(5)	10
	A=A+C	A		A.A = string addr
	AD0EX			A.A = @ IRAMBUFF,  D0 = $ addr
	C=DAT0	W		get old IRAMBUFF
	D0=A
	DAT0=C	W		restore it
* Update font address (in case we are in TEMPOB and we moved during EVAL)_
	D0=(2)	=Font
	D1=D1+	5		point to font
	C=DAT1	A		get font addr
	LA(5)	10
	C=C+A	A
	DAT0=C	A		update font address in case it moved due to GC
	D0=(2)	=STbits
	C=DAT0	A		saved ST reg
	ST=C
	C=B	A
	D0=C			D0 = addr of EVAL'ed ob
	GOTO	StdMenu
********
IsGrob!
** It is a grob, D0 points to prolog
	CD0EX
	D=C	A		save addr of grob in D.A
	GOSBVL	=D1=DSKTOP	D1 = addr STK1
* NOTE: =grob! uses IRAM, so save it in the $ on the stack
	C=R4.F	A
	RSTK=C			save IRAM
	D0=C			D0 = IRAM
	A=C	A		save copy of IRAM in A for later
	C=DAT1	A
	D1=C
	D1=D1+	10		point to string data
	C=DAT0	W		read
	DAT1=C	W		write
* use copy of IRAM
	AD1EX
* get the loop counter
	D1=(2)	=LoopCntr
	C=0	A
	C=DAT1	1
	C=C-1	B		option base 0
	B=C	B
* restore D0
	C=D	A
	D0=C			restore D0
* now calculate X,Y co-ordinates
	A=0	A
	R0=A.F	A		x co-ord. = zero
	LC(2)	22
	A=A-C	B		trap zero offset
ntlp	A=A+C	B
	B=B-1	B
	GONC	ntlp
	R1=A.F	A		y co-ord

	D1=(2)	=Sft1
	C=DAT1	A		@ first nib
	LA(5)	20
	C=C-A	A		@ prolog
	D1=C
* D0 = source (prolog)
* D1 = target (prolog)
* R0,R1 = x, y co-ord's
	GOSBVL	=grob!		Trashes *EVERYTHING* , 3 stack levels
	GOSBVL	=D1=DSKTOP
	C=RSTK
	R4=C.F	A		restore IRAM
* Now restore IRAM
	A=DAT1	A		A.A is addr STK1 (string)
	D1=C			D1 = IRAM
	D0=A			D0 = $
	D0=D0+	10		D0 = $ data (IRAM copy)
	C=DAT0	W
	DAT1=C	W
* Now we have to FLOSS the menu key (yes, just like your teeth!)
	D1=(2)	=LoopCntr
	C=0	A
	C=DAT1	1		get loop counter (1...6 for menu key 1->6)
	D1=(2)	=Sft1
	A=DAT1	A
	GOTO	fnx
fnx1	A=A+CON	A,6
fnx	C=C-1	B
	GONC	fmenu
	A=A-1	A
	D0=A			D0 = write addr
	LA(3)	#707
lpp1	C=DAT0	1
	C=C&A	P
	DAT0=C	1
	D0=D0+	16
	D0=D0+	16
	D0=D0+	2
	A=A-1	XS
	GONC	lpp1
	ST=0	sDoRTN		Don't do a RTN or we will crash
	GOTO	After$
fmenu	A=A+CON	A,5
	C=C-1	B
	GONC	fnx1
	D0=A			D0 = write addr
	LA(3)	#70D
	GOTO	lpp1

**** PortMenu! ***************************************************************
* Algorithm	: DTYPECSTR? ITE MakeStdLabel
*		  :: #:>$ $ ":" SWAP &$ MakeDirLabel ; Grob>Menu
*		  Done late at night without a GX to test on...
PortMenu!
	GOSUBL	Def->D0
	C=DAT0	A
	LA(5)	=DOCSTR
	?A#C	A		not a string ?
	GOYES	PM1
	GOSUB	size->#chars	it is string, so dispatch to normal key
	GOTO	DoKey
PM1	ST=1	sDIR
	D0=D0+	5
	C=DAT0	A		get #
	CD1EX			Save # in D1
** we need some space to make the string
	GOSBVL	=D0=DSKTOP
	C=DAT0	A
	D0=C
	D=C	A		save write address - 10
	D0=D0+	10
	LAASC	/:/
	DAT0=A	B
	D0=D0+	2
	AD1EX			a.a is bint
* D.W is safe through this call (it takes a hex number in A.A and writes
*                                its ascii representation to space at D0)
	GOSBVL	=#>DEC		a.a is bint, D0 = space --> 1st nib beyond
	LCASC	/:/
	DAT0=C	B
	D0=D0-	12		minus 10 (prolog) minus 2 (2 nibs past write)
	AD0EX
	C=D	A
	A=A-C	A
	ASRB.F	A		A.A is number of chars written - 2
	A=A+CON	A,2
	C=D	A
	C=C+CON	A,10
	D1=C
	C=A	A
	GOTO	Dolab2

**** size->#chars ************************************************************
* ENTRY	: D0  = address of prolog
* EXIT	: C.A = number of chars
*	: D0  = address of size
size->#chars
	D0=D0+	5		point to size
	C=DAT0	A		C.A is obj. length field
	C=C-CON	A,5		sub length field size
	CSRB.F	A		div 2
	RTN

**** DoKey *******************************************************************
* D0 = @ size
* C.A = number of chars
* check if C=0, then set sBLANK
DoKey	?C#0	A
	GOYES	notblank
blank	ST=1	sBLANK
notblank
	D0=D0+	5		point past size to data
Dolab1	AD0EX
	D1=A
Dolab2	D=C	A		put size in D
* D.A = number of chars in string
* D1  = @ first char
**** ShowLabel ****************************************************************
**
** Entry :	ST flags determine width
**		D.A = length of string
**		D1  = @ first nib data
*******************************************************************************
ShowLabel
	C=R4.F	A
	D0=C
	D0=(2)	=LoopCntr
	C=0	A
	C=DAT0	1		C.A = loop counter
	D0=(2)	=Sft1
	A=DAT0	A		A.A = @ HARDBUFF2
	C=C-1	B		option base 0
	GOTO	nx
nx1	A=A+CON	A,6
nx	C=C-1	B
	GONC	menu2
	ST=1	sEVEN
	GOTO	menu!
menu2	A=A+CON	A,5
	C=C-1	B
	GONC	nx1
	ST=0	sEVEN
*	GOTO	menu!		fall through to menu!

**** menu! ********************************************************************
* ENTRY : A.A = write addr
*	  D1  = (reserved)
*	  D.A = (reserved)
menu!	C=R4.F	A
	D0=C
	D0=(2)	=write@
	DAT0=A	A		save write address
	D0=A			D0 = write address
	CD1EX
	R0=C.F	A		Save D1 in R0
	D1=C
	?ST=0	sInvert		NOT white menu key ?
	GOYES	Nrm/Dir
isSOLV	?ST=1	sEVEN
	GOYES	Sevn
	GOTO	SOLVodd
Sevn	GOTO	SOLVevn
Nrm/Dir	?ST=1	sEVEN
	GOYES	NDevn
	GOTO	NDodd
******************************************************************************
* The first letter of each label (either E or O) refer to even/odd address
* on which the menu key grob resides (odd = need to shift data)
NDevn	?ST=0	sDIR
	GOYES	EStdKey
EDirKey	GOSUB	EWkey
	NIBHEX	E30000
	NIBHEX	FFFFFD
	NIBHEX	FFFFFD
EStdKey	GOSUB	EWkey
	NIBHEX	000000
	NIBHEX	FFFFFD
	NIBHEX	FFFFFD
NDodd	?ST=0	sDIR
	GOYES	OStdKey
ODirKey	GOSUB	OWkey
	NIBHEX	8F0000
	NIBHEX	CFFFF7
	NIBHEX	CFFFF7
OStdKey	GOSUB	OWkey
	NIBHEX	000000
	NIBHEX	CFFFF7
	NIBHEX	CFFFF7
SOLVevn	GOSUB	EWkey		even menu key, Invert
	NIBHEX	FFFFF1
	NIBHEX	100001
	NIBHEX	FFFFF1
SOLVodd	GOSUB	OWkey		odd menu key, Invert
	NIBHEX	CFFFF7
	NIBHEX	400004
	NIBHEX	CFFFF7
**** Even menu key sub-routine ************************************************
EWkey	C=RSTK
	D1=C			D1 = data address
	P=	6-1
	C=DAT1	WP		read 6 nibs
	DAT0=C	WP		write first line
	GOSUB	ENxtLine	point to next line on screen
	D1=D1+	6		point to next line of data to read
	LA(1)	8-1-2		6 lines to read & write
	C=DAT1	WP		all the same, so get data
ELp	DAT0=C	WP		write data
	GOSUB	ENxtLine	point to next line
	A=A-1	P		dec. loop counter
	GONC	ELp
	D1=D1+	6		next read address
	C=DAT1	WP		read/
	DAT0=C	WP		     write line
	P=	0
	GOTO	Write$
**** Even menu key sub-routine ***********************************************
ENxtLine
	D0=D0+	16
	D0=D0+	16
	D0=D0+	2
	RTN
***** Odd address menu key routines for writing the blank key ****************
OWkey	C=RSTK			get addr of data
	D1=C
	GOSUB	Fnib		mask & write first nib, incr D1,D0
	C=DAT1	A		read/write rest of line
	DAT0=C	A
	GOSUB	ONxtLine	next write line
	D1=D1+	5		next read line
	LA(1)	6-1		6 lines to write
	B=A	P		loop counter in B
OLp	GOSUB	Fnib		mask first nib
	C=DAT1	A		read/
	DAT0=C	A		     write rest of line
	GOSUB	ONxtLine	point to next line
	D1=D1-	1		back up read address
	B=B-1	P		dec. loop counter
	GONC	OLp		if CS then finished middle... now do last row
	D1=D1+	6		incr. read counter
	GOSUB	Fnib		mask & write first nib
	C=DAT1	A		rest of line
	DAT0=C	A
	GOTO	Write$		write string into display
**** Odd address menu key D0-->Next line *************************************
ONxtLine
	D0=D0+	16
	D0=D0+	16
	D0=D0+	1
	RTN
**** Odd address menu key mask routine ***************************************
* Algorithm	: we want 2 bits of info from the screen and 2 bits from the
*		: menukey data.
*		: So, get screen data, mask out what we don't want and OR
*		: it with menukey data (already masked).
Fnib	C=DAT0	P		get nib
	LA(1)	#3		mask
	C=C&A	P		get rid of what we don't want
	A=DAT1	P		get what we do want
	C=C!A	P		OR the two together
	DAT0=C	P		write back
	D1=D1+	1
	D0=D0+	1
	RTN
*** Def->D0 ******************************************************************
* Description	: returns the addr. of the display part of the menu key in D0
* ENTRY 	: any
* EXIT  	: D0 = @ definition for that row
* USES  	: A.A, C.A, D.A, D0,
******************************************************************************
Def->D0
** First, get the row number
	A=R4.F	A
	D0=A
	D0=(2)	=LoopCntr
	C=0	A
	C=DAT0	1		C.A is row number
** Now get the address of the thingie to show
	?ST=1	=sGX
	GOYES	getdfgx
	D0=(5)	=TOUCHTAB
	GOTO	getdfsx
getdfgx	D0=(5)	=G_TOUCHTAB
getdfsx A=DAT0  A
        D0=A                    D0 -> Touch Table
        D0=D0+  3               D0 -> Display Function Part
        AD0EX                   A[A] -> Display Function Part
	C=C-1   A               C[A] = N-1 (Row number-1)
	D=C     A
	C=C+C   A
	C=C+C   A
	C=C+D   A               C[A] = 5(N-1)
	A=A+C   A               A[A] -> slot
	D0=A                    D0 -> slot
        A=DAT0  A               A[A] -> object
	D0=A
        RTN
******************************************************************************
**		D.A = length of string
**		R0  = @ first nib data
** save maximum width
Write$
	?D#0	B		check for zero length to write
	GOYES	notnull
	ST=0	sDoRTN
	GOTO	After$
notnull	C=R0.F	A
	D1=C
	LC(5)	18
	?ST=1	sInvert
	GOYES	inv1
	LC(2)	20
inv1	B=C	A
	R0=C.F	A		max width
** save addr of font
	C=R4.F	A
	D0=C
	D0=(2)	=Font
	C=DAT0	A
	R2=C.F	A
** save addr of iram buffer (charaddr)
	D0=(2)	=charaddr
	CD0EX
	R3=C.F	A
	D0=C
*************************************************************
* Here:
*	R0 : max width		(used again)
*	R2 : @ offset table
*	R3 : @ IRAMBUFF data
*	R4 : IRAM BUFF START
*	A.A :
*	B.A : max width
*	C.A :
*	D.A : len$
*	D0 :
*	D1 : -> 1st chr

** compute the width of the string to display

	C=0	A		zero # of chars to write length

* Now we grab each char's width and calc the width & number of chars that fit
* D.A = number of chars left
* B.A = max width - width of chars so far
* C.A = number of chars so far that it is okay to write

cntlp
	D=D-1	A		Still chars to do ?
	GOC	done		will grab C.A as # of chars
	D0=C			save C

	C=R2.F	A		get addr of offset table
	A=0	A
	A=DAT1	B		A=000(ascii char)
	A=A+A	A
	A=A+A	A
	C=C+A	A		c = c + 4*A
	CD0EX			D0 = Jump table @,   C.A = # of chars so far
	A=0	A
	A=DAT0	4		get offset from this addr to data
	CD0EX			D0 = number of chars so far

	C=C+A	A		4 nibs !

	A=R3.F	A		get IRAMBUFF (current)
	AD0EX			save D0	in A
	DAT0=C	A		write char data addr
	D0=D0+	5		incr to next slot
	AD0EX			restore D0, put addr of next slot in A.A
	R3=A.F	A		save Addr of next slot

	CD0EX			D0 = @ size,bitmap data; C.A = # of chars
	A=0	A
	A=DAT0	1		get width (1 nib)

	B=B-A	A
	GOC	overdone
	C=C+1	A		that char fitted... go check next one
	D1=D1+	2		point to next char in $
	GOTO	cntlp
overdone
	B=B+A	A		B = max. width - actual width
done	D=C	A		D = # chars that fit

*****************************************************
* Here:
*	B[A]	limit - width
*	D[A]	# chars that fit
*	R0[A]	limit
*	R1[A]	-> $
*	R2[A]	address of jump table
*	R3[A]	IRAMBUFF data addr
*	R4[A]
* Now get starting offset, then do $->3x5 replacement
*****************************************************
	A=R0.F	A		Get limit
	A=A-B	A		A = width
	A=A+1	A		A = width+1
	ASRB.F	A		A= (width+1)/2
	LC(5)	11		point to center around (x)
	C=C-A	A		C= x-(width+1)/2 = x'
	GONC	centerxok
	C=0	A		fix width > 2*x
centerxok
	B=C	A
** Fix width to shift over
	C=R4.F	A
	D1=C
	D1=(2)	=LoopCntr
	A=0	A
	A=DAT1	1		C.A = loop counter
	A=A-1	B		option base 0
	LC(5)	22
ex2	A=A-1	B
	GOC	ex1
	B=B+C	A
	GOTO	ex2
ex1
** put write addr in D1
	D1=(2)	=Sft1
	A=DAT1	A
	LC(5)	34*2		34 nibs per line, 2 lines down
	C=C+A	A
	AD1EX			save IRAMBUFF in A.A
	D1=C			write addr
** read addr of string addresses in buffer
	LA(2)	=charaddr
	A=A-CON	A,5
	D0=A
	ST=0	sDoRTN
*	GOTO	CHARLOOP
******************************************************************************
* ENTRY : RSTK 	=
*	: D.A	= # number of chars to write
*	: B.A	= # of columns to shift over
*	: D0	= address of pointer to first char data - 5
*	: D1	= write @
*
* EXIT	: String written... NO CHECKS DONE !!!!!!!
******************************************************************************
CHARLOOP
	D=D-1	A			decrement character count
	GONC	char1			GOC was out of range
	GOTO	After$			CS when out of characters

** Compute the address of appropriate bit battern.
char1	D0=D0+	5			D0:address next character data
	C=DAT0	A
	CD0EX				D0:
	RSTK=C				save address of BUFFER

** Compute tracking nibble and write destination.
	A=B	A			C[A]:total pixel columns
	A=0	S			A[S]:intialized tracking
	SB=0
	ASRB.F	A
	?SB=0
	GOYES	divide2
	A=A+1	S			not div. by 2 so shove in extra bit
	SB=0
divide2	ASRB.F	A
	?SB=0				divisible by 4?
	GOYES	savdisp
	A=A+1	S			no, shove in 2 extra bits
	A=A+1	S
savdisp	CD1EX
	RSTK=C				put addr to write to in RSTK
	C=C+A	A
	D1=C				d1 is addr to write to

** Determine whether or not font will fit on remaining grob.
	A=0	A
	A=DAT0	1			A[A]:pixel width of font
	B=B+A	A			B[A]:total pixel columns

** Compute the MSB bits for mask.
	A=A+CON	B,9			A[B]:initialized counter
	LC(3)	#FF			C[0-11]:[0000|1111|1111]
rtshft1	CSRB.F	B	<---
	A=A+1	P	    |		compute MSB bits of mask
	GONC	rtshft1	 ---
	R1=C.F	X

** Initilize final loop paramaters.
	D0=D0+	1			point to char data
	P=	16-6

** Write loop for bit pattern-to-grob.
* P    = 16 - number of chars still to do
* D0   = @ char data
* D1   = write addr
* R1.X = mask
*
** Write loop for bit pattern-to-grob.
PIXLOOP	C=0	X	<-----------			     [ 6]
	C=DAT0	B		    |	get 2 nibs data      [15]
	A=R1.F	X		    |			     [ 9]
	C=A	S		    |			     [ 4]
	C=C-1	S		    |			     [ 4]
	GOC	setbyte		    |			[10]/[ 3]
rtshft2	A=A+A	X	<---	    |			     [ 6]
	C=C+C	X	    |	    |	shift grob data left [ 6]
	C=C-1	S	    |	    |			     [ 4]
	GONC	rtshft2	 ---	    |			[10]/[ 3]
setbyte
	?ST=0	sInvert
	GOYES	NormK
** this is for writing to a white/grey area
	A=-A-1	X		    |	A[B]:bit mask	     [ 6]
	RSTK=C			    |	RSTK:new bits	     [ 8]
	C=DAT1	X		    |	C[A]:old bits	     [20]
	A=A&C	X		    |	clears pixels	     [ 7]
	C=RSTK			    |	get pixel row	     [ 8]
	C=C!A	X		    |	add pixel row	     [ 7]
	A=DAT1	X			read screen data
	C=C!A	X			OR with pixel data
	GOTO	ANK
** this is for writing to a "black" area
NormK	A=DAT1	X
	C=-C-1	X
	C=C&A	X
ANK	DAT1=C	X		    |	set pixel row	     [19]
	D1=D1+	16
	D1=D1+	16
	D1=D1+	2
	D0=D0+	2		    |			     [ 7]
	P=P+1			    |			     [ 3]
	GONC	PIXLOOP	----------->			[10]/[ 3]
** Reset pointer registers for next character.
	C=RSTK
	D1=C
	C=RSTK
	D0=C
	GOTO	CHARLOOP
******************************************************************************
** end CHARLOOP **************************************************************

******************************************************************************
* After string written to display, check for oval display, do housekeeping
* and restart on next menu key
After$
* Check if we make menus oval....
	?ST=1	sDoRTN		these next two lines are do a RTN if the
	RTNYES			code is used by $>grob or DispStatus
	?ST=1	sOVAL
	GOYES	Ovals!
	GOTO	noOval
* Display Oval Menus
Ovals!	C=R4.F	A
	D0=C
	D0=(2)	=LoopCntr
	C=0	A
	C=DAT0	1
	C=C-1	P		option base 0
	D0=(2)	=Sft1
	A=DAT0	A
	GOTO	nnx
nnx1	A=A+CON	A,6
nnx	C=C-1	P
	GONC	nmenu
* even
	?ST=1	sInvert
	GOYES	ea1
* invert menu key, so invert the TOP line (as opposed to 2nd line down)
	LC(5)	34
	A=A+C	A
ea1	D0=A
	GOTO	k1
nmenu	A=A+CON	A,5
	C=C-1	P
	GONC	nnx1
* odd
	?ST=1	sInvert
	GOYES	ea2
	LC(5)	34
	A=A+C	A
ea2	D0=A
	GOTO	k2
*************************
noOval
* clear all unwanted bits in ST register
	C=ST			get bits
	LA(3)	#3F0		mask
	C=C&A	X		and with mask to kill unwanted bits
	ST=C			write bits
	C=R4.F	A
	D0=C
	D0=(2)	=LoopCntr
	C=0	A
	C=DAT0	1
	LA(2)	6
	?A=C	B
	GOYES	exit
	C=C+1	A
	DAT0=C	1
	?ST=0	sSOLV
	GOYES	NoSlv
	GOLONG	SolvrMenu!
NoSlv	?ST=0	sMATH
	GOYES	NoSup
	GOLONG	SuperMenus!
NoSup	?ST=0	sPORT
	GOYES	Std!
	GOLONG	PortMenu!
Std!	GOLONG	StdMenus!
exit	GOVLNG	=GETPTRLOOP

******************************************************************************
* oval menu key sub routines
k2	GOSUB	key2_sub
	?ST=1	sInvert
	GOYES	k20
	LA(5)	34*6-5
	GOTO	k21
k20	LA(5)	34*7-5
k21	CD0EX
	C=C+A	A
	D0=C
	GOSUB	key2_sub
	GOTO	noOval
***** OVAL MENU **********
k1	GOSUB	key1_sub
	?ST=1	sInvert
	GOYES	k10
	LA(5)	34*6-5
	GOTO	k11
k10	LA(5)	34*7-5
k11	CD0EX
	C=C+A	A
	D0=C
	GOSUB	key1_sub
	GOTO	noOval
key1_sub				write values for type 1
	C=DAT0	1
	CBIT=0	0
	DAT0=C	1
	D0=D0+	5
	C=DAT0	1
	CBIT=0	0
	DAT0=C	1
	RTN
key2_sub				write values for type 2
	C=DAT0	1
	CBIT=0	2
	DAT0=C	1
	D0=D0+	5
	C=DAT0	1
	CBIT=0	2
	DAT0=C	P
	RTN

**** InitBuff ****************************************************************
* Description	: Initiates the data buffer
* ENTRY		: after savptr,
* 		  STK2: Smallfont
*		  STK1: 16 nib buffer (temp copy of IRAM during RPL EVAL)
******************************************************************************
InitBuff
	D1=D1+	5		@ STK2
	C=DAT1	A
	LA(5)	5+5		5 nibs prolog + 5 nibs size
	C=C+A	A		@ of first nib data in font
* get machine independent IRAMBUFF address
	D0=(5)	(=IRAM@)-4
	A=DAT0	A
	LA(4)	#0100
	R4=A.F	A		save in R4.A
* Save @ of SmallFont
	D1=A			put data buffer @ in D0
	D1=(2)	=Font
	DAT1=C	A		save @ first nib of SmallFont in IRAMBUFF
** save loop counter ( 1 NIB )
	LC(5)	1
	D1=(2)	=LoopCntr
	DAT1=C	1

** Test if GX or SX
** Assumes CLRST has been done
	D0=(5)	=IRAM@
	C=DAT0	B
	?CBIT=0	3
	GOYES	setsx
	ST=1	=sGX		GX
setsx
** Initialise HARDBUFF2 address
	GOSBVL	=D0->Sft1	D0, A.A = @ first nib of HARDBUFF2
	D1=(2)	=Sft1
	DAT1=A	A

	?ST=1	sGX
	GOYES	nMgx
	D1=(5)	#706E4
	GOTO	nMsx
nMgx	D1=(5)	#80862
nMsx	C=DAT1	1
	?CBIT=1	2		User flag 63 SET ? -> further tests
	GOYES	IOval
	GOTO	Iend
* now check if CST menu is displayed
IOval	ST=1	sOVAL
	?ST=1	sGX
	GOYES	gxcode
*sx code
	D0=(5)	#7061E
	C=DAT0	A
	LA(5)	#3B239
	?A#C	A
	GOYES	nocst
	GOTO	cst!		CST menu !
nocst	GOTO	Iend
gxcode	D0=(5)	#8079D
	C=DAT0	A		get pointer
	D0=C
	D0=D0+	5		point past prolog
	LAHEX	0010A9		xlib 169 1
	P=	6-1
	C=DAT0	WP
	?C=A	WP
	GOYES	cst!		CST menu!
	P=	0
	GOTO	Iend
cst!	P=	0
	C=DAT1	1
	?CBIT=0	1		User flag 62 CLEAR? -> force Ovals
	GOYES	Iend
	ST=0	sOVAL
Iend	RTN

******************************************************************************

ASSEMBLE
endDoLabel
RPL
 2DROP				( drop smallfont and Buffer$ )
 SetDA3Valid			( signal redraw menu bar )
;

]])
